#lang play
(require "main.rkt")
(print-only-errors)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                 TESTS BASE                                  ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(test (run-val '{+ 1 2}) 3)
(test (run-val '{< 1 2}) #t)
(test (run-val '{- 2 1}) 1)
(test (run-val '{* 2 3}) 6)
(test (run-val '{= {+ 2 1} {- 4 1}}) #t)
(test (run-val '{and #t #f}) #f)
(test (run-val '{or #t #f}) #t)
(test (run-val '{not {not #t}}) #t)
(test (run-val '{if {not #f} {+ 2 1} 4}) 3)
(test (run-val '{with {{x 5} {y 3}}
                      {begin {+ x 1}
                             {+ x y}}}) 8)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                TESTS ENUNCIADO                              ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#|RECUERDE DESCOMENTAR LOS TEST|#

#;(test (run-val '{with {{c {class {x y}
                              {def init {}
                                {begin {set x 1} {set y 2}}}
                              {def init {init-x init-y}
                                {begin {set x init-x} {set y init-y}}}  
                              {def sum {z} {+ {get self x} {+ {get self y} z}}}
                              {def set-x {val} {set x val}}}}
                         {o {new c 3 4}}}
                        {begin
                          {-> o set-x {+ 1 3}}
                          {+ {-> o sum 3} {get o y}}}})
        15)

#;(test (run-val '{with {{A {class {}
                              {def apply {c} {-> {new c} m}}}}
                         {o {new A}}}
                        {-> o apply {class {x}
                                      {def init {} {set x 2}}
                                      {def m {} {get self x}}}}})
        2)

#;(test/exn (run-val '{begin {with {{A {class {x}
                               {def init {} {set x 2}}
                               {def init {init-x} {set x init-x}}
                               {def m {} {get self x}}}}}
                     10}
                   {new A}})
            "free identifier: A")

#;(test (run-val '{with {{x 10}
                   {A {class {}
                        {def m {y} {+ x y}}}}
                   {o {new A}}}
              {-> o m 1}})
        11)

#;(test/exn (run-val '{begin {with {{A {class {x y x}}}}
                     10}
                   {new A}})
            "error: duplicate fields")

#;(test/exn (run-val '{begin {with {{A {class {x}
                               {def init {init-x} {set x init-x}}
                               {def init {init-x} {set x 12}}}}}
                     10}
                   {new A}})
            "error: same arity constructor")

#;(test/exn (run-val '{begin {with {{A {class {x}
                               {def foo {a} {set x a}}
                               {def foo {b} {set x {+ b 1}}}}}}
                     10}
                   {new A}})
            "error: overloading method foo with the same arity")

#;(test/exn (run-val '{set x 1})
            "error: set outside of method")

#;(test/exn (run-val 'self)
            "error: self outside of method")

#;(test/exn (run-val '{with {{A {class {}}}
                   {o {new A}}}
              {get o z}})
            "error: field z not found")

#;(test/exn (run-val '{with {{A {class {x y} {def init {init-x init-y} {set x init-x}}}}
                   {o {new A 1 2}}}
              {get o y}})
            "error: field y not initialized")

#;(test/exn (run-val '{with {{A {class {}}}
                   {o {new A}}}
              {-> o m}})
            "error: method m not found")

#;(test/exn (run-val '{with {{x 10}
                   {A {class {x}}}
                   {o {new A x}}}
              1})
            "error: constructor not found")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                  SUS TESTS                                  ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

